local imgui    = require 'imgui'
local sampev   = require 'samp.events'
local encoding = require 'encoding'
local keys = require 'vkeys'
local ffi	   = require('ffi')
encoding.default = 'CP1251'


addEventHandler("onWindowMessage", function (msg, wparam, lparam) if msg == 6 then if wparam == 0 then gta = false elseif wparam == 1 then gta = true end end end)

json = {
    defPath = getWorkingDirectory()..'/config/',
    save = function(t,path)
        if not path:find('[\\/]') then
			path = json.defPath..path
		end 
        t = (t == nil and {} or (type(t) == 'table' and t or {}))
        local f = io.open(path,'w')
		f:write(encodeJson(t) or {}) 
		f:close() 
	end,
    load = function(t,path)
        if not path:find('[\\/]') then 
			path = json.defPath..path 
		end
        if not doesFileExist(path) then
			json.save(t,path)
		end
        local f = io.open(path,'r+')
		local T = decodeJson(f:read('*a')) 
		f:close() 
        return T
	end
}
local dontEvents = {
	--{textEvent=""},
	{textEvent="   "},
	{textEvent="       "},
}
local simpleEvents = { 
	--{textEvent="",event=""},
	{textEvent="  ",event="  VC$"},
	{textEvent="       ",event="  "},
	{textEvent="  (.+)$(.+) (.+)  ",event="  "},
	{textEvent="     ",event="      "},
	{textEvent="     (.+)!",event="     !"},
	{textEvent="    ",event="   "},
	{textEvent="   %,    %.",event="/findibiz"},
	{textEvent="   ",event=" "},
	{textEvent="(.+)   $(.+)    %!",event=" "},
	{textEvent="   BTC (.+)  %$(.+)",event=" "},
	{textEvent="   $(.+)  (.+) BTC",event=" "},
	{textEvent="   (.+) %,   %,     ",event=" "},
	{textEvent="  %:",event="  "},
	{textEvent="    %[%/jlock%]",event=" "},
	{textEvent=" (.+)!   (.+)   $(.+)",event="  "},
	{textEvent="%!     ",event="PayDay"},
	{textEvent="   ",event="  "},
	{textEvent="    ",event="  "},
	{textEvent="    ",event=" "},
	{textEvent="    ",event=" "},
	{textEvent="    ",event="   ."},
	{textEvent="   ",event="  "},
	{textEvent="  $(.+)",event="   /pay"},
	{textEvent="  ",event="  "},
	{textEvent="   ",event="  "},
	{textEvent="     !",event="   "},
	{textEvent="     10 !",event="  "},
	{textEvent="  $(.+)    ",event=" "},
	{textEvent=" (.+)       ",event="  "},
	{textEvent=" : (.+)",event="  "},
	{textEvent="{ffffff}  {33AA33}%$(.+) {ffffff}  %/ %-%.",event="/ "},
	{textEvent="   (.+)$.     ",event=" "},
	{textEvent="      $(.+)",event="   "},
	{textEvent="   (.+)   .",event=" "},
	{textEvent="       ",event=" "},
	{textEvent="     %,        !",event="PayDay"},
	{textEvent=" : (.+)  (.+) %.    ",event="PayDay"},
	{textEvent="           ",event="  "},
	{textEvent="   (.+) ",event=" "},
	{textEvent="  ",event="   "},
	{textEvent="  $(.+)",event=" "},
	{textEvent="    ",event=" "},
	{textEvent="   %[ (.+) %] %: (.+)",event="  "},
	{textEvent="  ",event="  "},
	{textEvent=" %/unrentcar%,    ",event=" "}
}

local gta            = true
local u8             = encoding.UTF8
local j              = json.load({},'salary.json')
local balancePlayer  = 0
local events         = ""
local tag            = "[Salary_Menu]"
local colorText      = "{FAF0E6} "
local colorError     = "{FA8072} "
local color          = 0xDAA520
local moving         = false
local slider         = imgui.ImFloat(0)
local showMainWindow = imgui.ImBool(false)
local showStats      = imgui.ImBool(true)
local showWar        = imgui.ImBool(false)
local bankCounting   = imgui.ImBool(false)
local detailStats = imgui.ImBool(false)
local estStats       = imgui.ImBool(true)
local sessionStats   = imgui.ImBool(true)
local nowStats = imgui.ImBool(true)
local menu           = {true,false,false,false,false}
local countPD        = 0
local azcoins 		= 0
local banking        = false
local all 			 = true
local allminus 		 = false
local allplus 		 = false
local editTable      = false
local dont_count = false 
local summoney = 0
local sessionSum = 0 
local text_buffer    = imgui.ImBuffer(256)
local session        = {} 
local lower, sub, char, upper = string.lower, string.sub, string.char, string.upper
local concat = table.concat

-- initialization table
local lu_rus, ul_rus = {}, {}
for i = 192, 223 do
    local A, a = char(i), char(i + 32)
    ul_rus[A] = a
    lu_rus[a] = A
end
local E, e = char(168), char(184)
ul_rus[E] = e
lu_rus[e] = E
function chatmsg(text) sampAddChatMessage(tag..colorText..text,color) end
function errormsg(text) sampAddChatMessage(tag..colorError..text,color) end

function main()
	while not isSampAvailable() do wait(100) end
	repeat wait(0) until sampIsLocalPlayerSpawned()
	
	nickname = sampGetPlayerNickname(select(2, sampGetPlayerIdByCharHandle(playerPed)))
	ip, port = sampGetCurrentServerAddress()
	nick = nickname.." "..ip..":"..port
	
	
	j = json.load({},'salary.json')
	checkingJson()
	sampShowDialog(228, "{DAA520}salary", "", "OK", "", DIALOG_STYLE_MXGBOX)
	wait(1)
	sampCloseCurrentDialogWithButton(0)
	chatmsg(" , {DAA520}" .. nickname)
	chatmsg(".    {DAA520}/salary")
	balancePlayer = getPlayerMoney()
	sessionTime = os.time()
	scriptReady = true
	sampRegisterChatCommand("salary",function() showMainWindow.v = not showMainWindow.v end)
	
	while true do
		wait(10)
		imgui.Process = gta and true
		
		if sampIsLocalPlayerSpawned() then
			local nickname = sampGetPlayerNickname(select(2, sampGetPlayerIdByCharHandle(playerPed)))
			local ip, port = sampGetCurrentServerAddress()
			nicknew = nickname.." "..ip..":"..port
			if nicknew ~= nick then 
				balancePlayer = getPlayerMoney()
				--if balancePlayer ~= j[nick][date].salary then
				--customJson(tonumber(j[nick][date].salary) - balancePlayer,' ')
				--perechet()
				--end
				nick = nicknew
			end
			checkingJson() --       jsonom
			date   = tonumber(os.date("%d"))
			dayEst = tonumber(os.date("%d")) - 1
			
			date    = tostring(formatDate(date))
			dateEst = tostring(formatDate(dayEst))
			orgsalary      = j[nick][date].orgsalary   or 0 
			deposit        = j[nick][date].deposit     or 0
			salary         = j[nick][date].salary      or 0 
			plusMoney = j[nick][date].plusmoney or 0
			minusMoney = j[nick][date].minusmoney or 0
			countPD        = j[nick][date].payday      or 0
			azcoins      = j[nick][date].azcoins or 0 
			salaryEst      = j[nick][dateEst].salary   or 0
			posX           = j[nick].settings.x 	   or 0 
			posY           = j[nick].settings.y 	   or 0
			if j[nick].settings.fontsize ~= nil then slider.v       = j[nick].settings.fontsize else slider.v       = 20    end
			if j[nick].settings.banking  ~= nil then bankCounting.v = j[nick].settings.banking  else bankCounting.v = false end
			if j[nick].settings.stats    ~= nil then showStats.v    = j[nick].settings.stats    else showStats.v    = true  end
			if j[nick].settings.estStats ~= nil then estStats.v     = j[nick].settings.estStats else estStats.v     = true  end
			if j[nick].settings.detailStats ~= nil then detailStats.v     = j[nick].settings.detailStats else detailStats.v     = true  end
			if j[nick].settings.sessionStats ~= nil then sessionStats.v     = j[nick].settings.sessionStats else sessionStats.v     = true  end
			if j[nick].settings.nowStats ~= nil then nowStats.v = j[nick].settings.nowStats else nowStats.v = true end
			if balancePlayer ~= getPlayerMoney() then
				wait(10)
				if not banking and not dont_count then countingSalary() else 
					banking = false 
					dont_count = false
					balancePlayer = getPlayerMoney()
				end
			end
		end
		
	end
end

function imgui.BeforeDrawFrame()
    if fontsize == nil then
        fontsize = imgui.GetIO().Fonts:AddFontFromFileTTF(getFolderPath(0x14) .. '\\trebucbd.ttf', j[nick].settings.fontsize, nil, imgui.GetIO().Fonts:GetGlyphRangesCyrillic()) --  30   
	end
end


function imgui.OnDrawFrame()
	if not showMainWindow.v then
		imgui.ShowCursor = false
	end
	sw,sh = getScreenResolution()
	if showStats.v then 
		imgui.SetNextWindowPos(imgui.ImVec2(j[nick].settings.x,j[nick].settings.y),imgui.Cond.FirstUseEver)
		imgui.Begin('Salary ',showStats,imgui.WindowFlags.NoTitleBar + imgui.WindowFlags.AlwaysAutoResize) 
		statsX = imgui.GetWindowPos().x
		statsY = imgui.GetWindowPos().y
		imgui.PushFont(fontsize)
		if nowStats.v then 
		imgui.Text(u8'  ')  --       .  .     
		imgui.TextColoredRGB(salary > 0 and u8'{1BC500}+'..sep(salary)..' $' or salary == 0 and u8'{696969}'..sep(salary)..' $' or salary < 0 and u8'{f55442}'..sep(salary)..' $')  
		end
		if detailStats.v then
			imgui.Text(u8'  ')
			imgui.TextColoredRGB(plusMoney > 0 and u8'{1BC500}+'..sep(plusMoney)..' $' or plusMoney == 0 and u8'{696969}'..sep(plusMoney)..' $')		
			imgui.Text(u8'  ')
			imgui.TextColoredRGB(minusMoney == 0 and u8'{696969}'..sep(minusMoney)..' $' or minusMoney < 0 and u8'{f55442}'..sep(minusMoney)..' $')			
		end
		if estStats.v then 
			imgui.Text(u8'  ')
			imgui.TextColoredRGB(salaryEst > 0 and u8'{1BC500}+'..sep(salaryEst)..' $' or salaryEst == 0 and u8'{696969}'..sep(salaryEst)..' $' or salaryEst < 0 and u8'{f55442}'..sep(salaryEst)..' $')
		end
		if sessionStats.v then --  ,       
			imgui.Text(u8'  c')
			imgui.TextColoredRGB(sessionCount() > 0 and u8'{1BC500}+'..sep(sessionCount())..' $' or sessionCount() == 0 and u8'{696969}'..sep(sessionCount())..' $' or sessionCount() < 0 and u8'{f55442}'..sep(sessionCount())..' $')		
		end
		imgui.PopFont()
		imgui.End() 
	end
	if showMainWindow.v then
		imgui.ShowCursor = true
		imgui.SetNextWindowPos(imgui.ImVec2(sw / 2, sh / 2), imgui.Cond.FirstUseEver, imgui.ImVec2(0.5, 0.5))
		imgui.SetNextWindowSize(imgui.ImVec2(sw / 1.5,sh / 1.5),imgui.Cond.FirstUseEver)
		imgui.Begin(u8'SalaryMenu ' .. sepDate(date),showMainWindow)
		if imgui.Button(u8"", imgui.ImVec2(135, 30)) then uu() menu[1] = true end
		if imgui.Button(u8"", imgui.ImVec2(135, 30)) then uu() menu[2] = true end
		if imgui.Button(u8"", imgui.ImVec2(135, 30)) then uu() menu[3] = true end
		if imgui.Button(u8'  .',imgui.ImVec2(135, 30)) then uu() menu[4] = true end
		if imgui.Button(u8'', imgui.ImVec2(135, 30)) then uu() menu[5] = true end
		--     -- 
		imgui.SetCursorPosX(150)
		imgui.SetCursorPosY(30)
		if menu[1] then 
			imgui.BeginChild('menu1')
			imgui.SetCursorPosX(10)
			imgui.SetCursorPosY(10)
			imgui.BeginChild('podmenu1')
			imgui.Text(u8' :') imgui.SameLine()
			imgui.TextColoredRGB("{696969}"..countPD)
			--imgui.Text(u8'  :') imgui.SameLine()
			--imgui.TextColoredRGB(salary > 0 and u8'{1BC500}+'..sep(salary)..' $' or salary == 0 and u8'{696969}'..sep(salary)..' $' or salary < 0 and u8'{f55442}'..sep(salary)..' $')  
			imgui.Text(u8'  :') imgui.SameLine()
			imgui.TextColoredRGB(deposit > 0 and u8'{1BC500}+'..sep(deposit)..' $' or deposit == 0 and u8'{696969}'..sep(deposit)..' $' or deposit < 0 and u8'{f55442}'..sep(deposit)..' $')  
			imgui.Text(u8' :') imgui.SameLine()
			imgui.TextColoredRGB(orgsalary > 0 and u8'{1BC500}+'..sep(orgsalary)..' $' or orgsalary == 0 and u8'{696969}'..sep(orgsalary)..' $' or orgsalary < 0 and u8'{f55442}'..sep(orgsalary)..' $') 
			imgui.SetCursorPosX(200)
			if all then 
				imgui.TextColoredRGB(salary > 0 and '   [ {1BC500}+' .. sep(salary) .. "${FFFFFF} ]" or salary < 0 and '   [ {f55442}' .. sep(salary) .. "${FFFFFF} ]" or '  [ {696969}' .. sep(salary) .. "${FFFFFF} ]")
				elseif allminus then
				imgui.TextColoredRGB(minusMoney < 0 and '   [ {f55442}' .. sep(minusMoney) .. "${FFFFFF} ]" or '  [ {696969}' .. sep(minusMoney) .. "${FFFFFF} ]")
				else
				imgui.TextColoredRGB(plusMoney > 0 and '   [ {1BC500}+' .. sep(plusMoney) .. "${FFFFFF} ]" or '  [ {696969}' .. sep(plusMoney) .. "${FFFFFF} ]")			
			end
			if imgui.Button(u8' ',imgui.ImVec2(135, 20)) then all = true allminus = false allplus = false summoney = 0 end
			imgui.SameLine()
			if imgui.Button(u8'',imgui.ImVec2(135, 20)) then all = false allminus = false allplus = true summoney = 0 end
			imgui.SameLine()
			if imgui.Button(u8'',imgui.ImVec2(135, 20)) then all = false allminus = true allplus = false summoney = 0 end
			imgui.InputText(u8'', text_buffer)
			imgui.Separator()
			imgui.Columns(5,'columnsnow',true) 
			imgui.SetColumnWidth(0,30)
			imgui.SetColumnWidth(1,80)
			imgui.SetColumnWidth(2,110)
			imgui.SetColumnWidth(3,110)
			imgui.Text('X')
			imgui.NextColumn()
			imgui.Text(u8'') 
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Separator()
			for k,v in pairs(j[nick][date].log) do
				if allminus then 
					
					if v.editMoney < 0 then
						if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
							if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
								j[nick][date].log[k] = nil
								json.save(j,'salary.json')
								perechet()
							end
							imgui.NextColumn()
							imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
							imgui.NextColumn()
							imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
							imgui.NextColumn()
						imgui.TextColoredRGB(u8'{f55442} '..sep(v.editMoney).."$")	
							imgui.NextColumn()
							imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
							imgui.NextColumn()
							
						end
					end
				end
				if allplus then 
					if v.editMoney > 0 then
						if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
							if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
								j[nick][date].log[k] = nil
								json.save(j,'salary.json')
								perechet()
							end
							imgui.NextColumn()
							imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
							imgui.NextColumn()
							imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
							imgui.NextColumn()
							imgui.TextColoredRGB(u8'{1BC500} +'..sep(v.editMoney).."$")
							imgui.NextColumn()
							imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
							imgui.NextColumn()
						end
					end
				end
				if all then 
					if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
						if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
							j[nick][date].log[k] = nil
							json.save(j,'salary.json')
							perechet()
						end
						imgui.NextColumn()
						imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
						imgui.NextColumn()
						imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
						imgui.NextColumn()
							imgui.TextColoredRGB(v.editMoney > 0 and u8'{1BC500} +'..sep(v.editMoney).."$" or v.editMoney == 0 and u8'{696969} '..sep(v.editMoney).."$" or v.editMoney < 0 and u8'{f55442} '..sep(v.editMoney).."$")
						imgui.NextColumn()
						imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
						imgui.NextColumn()
					end
				end
				
			end
			imgui.EndChild()
			imgui.EndChild()
			
			
			
		end
		--     -- 
		if menu[2] then
			imgui.BeginChild('menu2')
			local date = os.date("%d%m%y")		
			date = tonumber(date)
			local dayWeek = tonumber(os.date("%w"))
			local dayAllWeek = tonumber(os.date("%d"))
			dayInWeek  = tonumber(os.date("%d"))
			if dayWeek == 0 then dayWeek = 7 end			
			salaryWeek = 0
			t = {u8" ",u8" ",u8" ",u8" ",u8" ",u8" ",u8" "}
			n = dayWeek + 1
			dateDayInWeek = formatDate(dayInWeek)
			if j[nick][dateDayInWeek] ~= nil then
				
				for i=1,10 do
					local dayStartWeek = dayAllWeek - (dayWeek-1)
					local dayEndWeek = dayAllWeek + (7-(dayWeek))
					local startWeek = formatDate(dayStartWeek)
					local endWeek = formatDate(dayEndWeek)
					if j[nick][startWeek] ~= nil or j[nick][endWeek] ~= nil then
						if imgui.CollapsingHeader(u8""..sepDate(startWeek).." - "..sepDate(endWeek)) then
							local sumWeek = countWeekSalary(dayStartWeek)
							imgui.SetCursorPosX(20)
							imgui.Text(u8": ") 
							imgui.SameLine()
							imgui.TextColoredRGB((sumWeek > 0 and u8'{1BC500} +'..sep(sumWeek)..' $' or sumWeek == 0 and u8'{696969} '..sep(sumWeek)..' $' or sumWeek < 0 and u8'{f55442} '..sep(sumWeek)..' $'))
							for i = 1,7 do
								startWeek = formatDate(dayStartWeek)
								if j[nick][startWeek] ~= nil then
									imgui.SetCursorPosX(20)
									if imgui.CollapsingHeader(u8''..t[i]..sepDate(startWeek)) then 
										imgui.SetCursorPosX(20)
										local salary = j[nick][startWeek].salary or 0 
										local minusMoney = j[nick][startWeek].minusmoney or 0
										local plusMoney = j[nick][startWeek].plusmoney or 0 
										if all then 
											imgui.TextColoredRGB(salary > 0 and '   [ {1BC500}+' .. sep(salary) .. "${FFFFFF} ]" or salary < 0 and '   [ {f55442}' .. sep(salary) .. "${FFFFFF} ]" or '  [ {696969}' .. sep(salary) .. "${FFFFFF} ]")
											elseif allminus then
											imgui.TextColoredRGB(minusMoney < 0 and '   [ {f55442}' .. sep(minusMoney) .. "${FFFFFF} ]" or '  [ {696969}' .. sep(minusMoney) .. "${FFFFFF} ]")
											else
											imgui.TextColoredRGB(plusMoney > 0 and '   [ {1BC500}+' .. sep(plusMoney) .. "${FFFFFF} ]" or '  [ {696969}' .. sep(plusMoney) .. "${FFFFFF} ]")			
										end
										if imgui.Button(u8' ##'..startWeek,imgui.ImVec2(135, 20)) then all = true allminus = false allplus = false end
										imgui.SameLine()
										if imgui.Button(u8'##'..startWeek,imgui.ImVec2(135, 20)) then all = false allminus = false allplus = true end
										imgui.SameLine()
										if imgui.Button(u8'##'..startWeek,imgui.ImVec2(135, 20)) then all = false allminus = true allplus = false end
										imgui.SetCursorPosX(20)
										imgui.InputText(u8'', text_buffer)
										imgui.SetCursorPosX(20)
										imgui.BeginChild(startWeek.."een")
										imgui.Columns(5,startWeek..'##startWeek',true)
										imgui.SetColumnWidth(0,30)
										imgui.SetColumnWidth(1,80)
										imgui.SetColumnWidth(2,110)
										imgui.SetColumnWidth(3,110)
										imgui.Separator()
										imgui.Text('X')
										imgui.NextColumn()
										imgui.Text(u8'') 
										imgui.NextColumn()
										imgui.Text(u8'')
										imgui.NextColumn()
										imgui.Text(u8'')
										imgui.NextColumn()
										imgui.Text(u8'')
										imgui.NextColumn()
										imgui.Separator()
										if j[nick][startWeek] ~= nil then
											
											for k,v in pairs(j[nick][startWeek].log) do
												if allminus then 
													if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
														if v.editMoney < 0 then
															if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
																j[nick][startWeek].log[k] = nil
																json.save(j,'salary.json')
																perechet()
															end
															imgui.NextColumn()
															imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
															imgui.NextColumn()
															imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
															imgui.NextColumn()
															imgui.TextColoredRGB(v.editMoney > 0 and u8'{1BC500} +'..sep(v.editMoney).."$" or v.editMoney == 0 and u8'{696969} '..sep(v.editMoney).."$" or v.editMoney < 0 and u8'{f55442} '..sep(v.editMoney).."$")
															imgui.NextColumn()
															imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
															imgui.NextColumn()
														end
													end
												end
												if allplus then 
													if v.editMoney > 0 then
														if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
															if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
																j[nick][startWeek].log[k] = nil
																json.save(j,'salary.json')
																perechet()
															end
															imgui.NextColumn()
															imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
															imgui.NextColumn()
															imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
															imgui.NextColumn()
															imgui.TextColoredRGB(v.editMoney > 0 and u8'{1BC500} +'..sep(v.editMoney).."$" or v.editMoney == 0 and u8'{696969} '..sep(v.editMoney).."$" or v.editMoney < 0 and u8'{f55442} '..sep(v.editMoney).."$")
															imgui.NextColumn()
															imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
															imgui.NextColumn()
														end
													end
												end
												if all then 
													if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
														if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
															j[nick][startWeek].log[k] = nil
															json.save(j,'salary.json')
															perechet()
														end
														imgui.NextColumn()
														imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
														imgui.NextColumn()
														imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
														imgui.NextColumn()
														imgui.TextColoredRGB(v.editMoney > 0 and u8'{1BC500} +'..sep(v.editMoney).."$" or v.editMoney == 0 and u8'{696969} '..sep(v.editMoney).."$" or v.editMoney < 0 and u8'{f55442} '..sep(v.editMoney).."$")	
														imgui.NextColumn()
														imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
														imgui.NextColumn()
													end
												end
											end
											
										end
										imgui.EndChild()
									end
								end
								dayStartWeek = dayStartWeek + 1
							end
							imgui.Text('')
						end
					end
					dayAllWeek = dayAllWeek - 7
				end
			end		
			imgui.EndChild()
		end		
		if menu[3] then
			imgui.BeginChild('menu3')
			imgui.Text(u8'  ')
			imgui.TextColoredRGB(sessionSum > 0 and '   [ {1BC500}+' .. sep(sessionSum) .. "${FFFFFF} ]" or sessionSum < 0 and '   [ {f55442}' .. sep(sessionSum) .. "${FFFFFF} ]" or '  [ {696969}' .. sep(sessionSum) .. "${FFFFFF} ]")
			if imgui.Button(u8' ##session',imgui.ImVec2(135, 20)) then all = true allminus = false allplus = false sessionSum = 0 end
			imgui.SameLine()
			if imgui.Button(u8'##session',imgui.ImVec2(135, 20)) then all = false allminus = false allplus = true sessionSum = 0 end
			imgui.SameLine()
			if imgui.Button(u8'##session',imgui.ImVec2(135, 20)) then all = false allminus = true allplus = false sessionSum = 0 end
			imgui.SameLine()
			if imgui.Button(u8' ', imgui.ImVec2(135,20)) then 
				sessionTime = os.time() 
				sessionSum = 0
			end
			imgui.InputText(u8'', text_buffer)
			imgui.Columns(5,'tablesession',true)
			imgui.Separator()
			imgui.SetColumnWidth(0,30)
			imgui.SetColumnWidth(1,80)
			imgui.SetColumnWidth(2,110)
			imgui.SetColumnWidth(3,110)
			imgui.Text(u8'X')
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.Separator()
			imgui.NextColumn()
			-- sessing = {time,balance,editMoney,eventsMoney} 
			
			for k,v in pairs(j[nick][date].log) do
				
				if v.time > sessionTime then 
					
					if allminus then 
						sessionSum = sessionCount()
						if v.editMoney < 0 then
							if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
								if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
									j[nick][date].log[k] = nil
									json.save(j,'salary.json')
									perechet()
								end
								imgui.NextColumn()
								imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
								imgui.NextColumn()
								imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
								imgui.NextColumn()
								imgui.TextColoredRGB(v.editMoney > 0 and u8'{1BC500} +'..sep(v.editMoney).."$" or v.editMoney == 0 and u8'{696969} '..sep(v.editMoney).."$" or v.editMoney < 0 and u8'{f55442} '..sep(v.editMoney).."$")
								imgui.NextColumn()
								imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
								imgui.NextColumn()
								
							end
							
						end
					end
					if allplus then 
						if v.editMoney > 0 then
							sessionSum = sessionCount()
							if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
								if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
									j[nick][date].log[k] = nil
									json.save(j,'salary.json')
									perechet()
								end
								imgui.NextColumn()
								imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
								imgui.NextColumn()
								imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
								imgui.NextColumn()
								imgui.TextColoredRGB(v.editMoney > 0 and u8'{1BC500} +'..sep(v.editMoney).."$" or v.editMoney == 0 and u8'{696969} '..sep(v.editMoney).."$" or v.editMoney < 0 and u8'{f55442} '..sep(v.editMoney).."$")
								imgui.NextColumn()
								imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
								imgui.NextColumn()
							end
						end
					end
					if all then 
						sessionSum = sessionCount()
						if string.find(string.nlower(v.eventsMoney,nil,true),string.nlower(u8:decode(text_buffer.v)),nil,true) then
							if imgui.Button(u8'x##'..k,imgui.ImVec2(15, 15)) then
								j[nick][date].log[k] = nil
								json.save(j,'salary.json')
								perechet()
							end
							imgui.NextColumn()
							imgui.Text(('[%s]'):format(os.date('%H:%M:%S',v.time)))
							imgui.NextColumn()
							imgui.Text(v.cash ~= nil and sep(v.cash).."$" or "")
							imgui.NextColumn()
							imgui.TextColoredRGB(v.editMoney > 0 and u8'{1BC500} +'..sep(v.editMoney).."$" or v.editMoney == 0 and u8'{696969} '..sep(v.editMoney).."$" or v.editMoney < 0 and u8'{f55442} '..sep(v.editMoney).."$")	
							imgui.NextColumn()
							imgui.Text(v.eventsMoney ~= "" and u8(v.eventsMoney) or "")
							imgui.NextColumn()
						end
					end
					
				end
				
			end
			imgui.EndChild()
		end
		if menu[4] then
			imgui.BeginChild('menu4')
			imgui.Text(u8' PayDay')
			imgui.Separator()
			imgui.SetCursorPosX(10)
			imgui.Columns(5,'tabledep',true) --    
			imgui.SetColumnWidth(0,80)
			imgui.SetColumnWidth(1,110)
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Text(u8'')
			imgui.NextColumn()
			imgui.Text(u8'.')
			imgui.NextColumn()
			imgui.Text(u8' ')
			imgui.NextColumn()
			imgui.Text(u8'-')
			imgui.NextColumn()
			imgui.Separator() --    
			local depday = os.date("%d")
			for i = 1,100 do --     ,     json,         .
				depdate = formatDate(depday)
				if j[nick][depdate] ~= nil then
					local deposit = j[nick][depdate].deposit or 0
					local orgsalary = j[nick][depdate].orgsalary or 0
					local payday = j[nick][depdate].payday or 0 
					local azcoins = j[nick][depdate].azcoins or 0 
					imgui.Text(sepDate(depdate))
					imgui.NextColumn()
					imgui.TextColoredRGB(deposit > 0 and u8'{1BC500} +'..sep(deposit).."$" or u8'{696969} '..sep(deposit).."$")
					imgui.NextColumn()
					imgui.TextColoredRGB(orgsalary > 0 and u8'{1BC500} +'..sep(orgsalary).."$" or u8'{696969} '..sep(orgsalary).."$")
					imgui.NextColumn()
					imgui.TextColoredRGB(u8"{696969}"..payday)
					imgui.NextColumn()
					imgui.TextColoredRGB(u8"{696969}"..azcoins)
					imgui.NextColumn()
				end
				depday = depday - 1
			end
			imgui.EndChild()
		end
		--   -- 
        if menu [5] then	
			imgui.BeginChild('menu5')
			imgui.SliderFloat(u8" ", slider, 10, 50)
			if slider.v ~= j[nick].settings.fontsize then
				j[nick].settings.fontsize = tonumber(slider.v)				
				json.save(j,'salary.json')
			end
			if imgui.Button(u8" ") then
				showMainWindow.v = false
				imgui.ShowCursor = false
				chatmsg(" ")
				thisScript():reload()
			end
			imgui.SameLine()
			if imgui.Button(u8" ") then
				perechet()
				chatmsg('   ')
			end		
			if imgui.Button(u8"  ") then
				j[nick].settings.x = statsX
				j[nick].settings.y = statsY
				json.save(j,'salary.json')		
				chatmsg("  ")
			end
			if imgui.Checkbox(u8"  ",showStats) then 
				j[nick].settings.stats = showStats.v
				json.save(j,"salary.json") 
				if showStats.v then chatmsg('  ') else chatmsg('  .') end
			end
			if showStats.v then 
				if imgui.Checkbox(u8"   ",nowStats) then
					j[nick].settings.nowStats = nowStats.v
					json.save(j,"salary.json")
					if nowStats.v then chatmsg('    ') else chatmsg('    ') end
				end
				if imgui.Checkbox(u8"   ",estStats) then --       
					j[nick].settings.estStats = estStats.v
					json.save(j,"salary.json") 
					if estStats.v then chatmsg('    ') else chatmsg('    .') end
				end
				if imgui.Checkbox(u8"   ",sessionStats) then 
					j[nick].settings.sessionStats = sessionStats.v
					json.save(j,"salary.json") 
					if sessionStats.v then chatmsg('    ') else chatmsg('    .') end
				end
				if imgui.Checkbox(u8"  /", detailStats) then
					j[nick].settings.detailStats = detailStats.v
					json.save(j,"salary.json")
					if detailStats.v then chatmsg('     ') else chatmsg('     ') end
				end
				--[[if imgui.Checkbox(u8'  ',moving) then
					imgui.SetWindowFocus('Salary')
					chatmsg('     ,    ')
				end]]--
			end
			if imgui.Checkbox(u8"   ",bankCounting) then 
				j[nick].settings.banking = bankCounting.v
				json.save(j,"salary.json") 
				if showStats.v then chatmsg('   ') else chatmsg('   ') end
			end
			if imgui.Button(u8' ') then
				showWar.v = true
				
			end
			imgui.Separator()
			imgui.TextWrapped(u8"* ,    ,    ' '")
			imgui.TextWrapped(u8"*        ,      ,      '  '")
			imgui.TextWrapped(u8"*           ' '")
			imgui.EndChild()
			
		end
		--    .   -- 
		
		imgui.End()
		
		if showWar.v then
			imgui.SetNextWindowSize(imgui.ImVec2(200,100),imgui.Cond.FirstUseEver)
			imgui.SetNextWindowPos(imgui.ImVec2(sw / 2, sh / 2), imgui.Cond.FirstUseEver, imgui.ImVec2(0.5, 0.5))
			imgui.Begin(u8'',showWar,imgui.WindowFlags.NoTitleBar + imgui.WindowFlags.AlwaysAutoResize)
			imgui.Text(u8" ,    ?")
			imgui.SetCursorPosX(100)
			if imgui.Button(u8'') then
				chatmsg('   ')
				deleteStats()
				showWar.v = false
			end	
			imgui.SameLine()
			if imgui.Button(u8"") then
				showWar.v = false
			end
			imgui.End()
		end
	end
end

function countingSalary()
	date   = tonumber(os.date("%d"))
	dayEst = tonumber(os.date("%d")) - 1
	date    = tostring(formatDate(date))
	dateEst = tostring(formatDate(dayEst))
	checkingJson()
	if balancePlayer < getPlayerMoney(Player) then --   
		diffBalance = math.abs(balancePlayer - getPlayerMoney(Player))
		plusMoney = plusMoney + diffBalance
		salary = salary + diffBalance
		j[nick][date].plusmoney = plusMoney
		j[nick][date].salary=salary
		json.save(j,'salary.json')
		if diffBalance ~= nil then writejson(diffBalance) else errormsg('    ') end
		balancePlayer = getPlayerMoney()
		elseif balancePlayer > getPlayerMoney(Player) then --   
		diffBalance = -balancePlayer + getPlayerMoney(Player)
		minusMoney = minusMoney + diffBalance
		salary = salary + diffBalance
		j[nick][date].minusmoney = minusMoney
		j[nick][date].salary=salary
		json.save(j,'salary.json')
		if diffBalance ~= nil then writejson(diffBalance)  else errormsg('    ') end
		balancePlayer = getPlayerMoney()
	end
	
	
end

function sessionCount()
	local money = 0
	for k,v in pairs(j[nick][date].log) do
		if v.time >= sessionTime then
			if allminus == true then 
				if v.editMoney < 0 then
					money = money + v.editMoney
				end
			end
			if allplus == true then 
				if v.editMoney > 0 then
					money = money + v.editMoney
				end
			end
			if all == true then 
				money = money + v.editMoney
			end
		end
	end
	return money
end

function countSum(date)
	money = 0
	if allminus == true then 
		for k,v in pairs(j[nick][date].log) do
			if v.editMoney < 0 then
				money = money + v.editMoney
			end
		end
	end
	if allplus == true then 
		for k,v in pairs(j[nick][date].log) do
			if v.editMoney > 0 then
				money = money + v.editMoney
			end
		end
	end
	if all == true then 
		for k,v in pairs(j[nick][date].log) do
			money = money + v.editMoney
		end
	end
	return money
end


function sampev.onServerMessage(color,text)
	
	events = '* '..text
	for _,v in ipairs(dontEvents) do
		if text:find(v.textEvent) then
			dont_count = true
			break
		end
	end
	for _,v in ipairs(simpleEvents) do
		if text:find(v.textEvent) then
			events = v.event
			break
		end
	end
	if string.find(text,"   :") or string.find(text,"  :") then
		depmoney = text:gsub(',', ''):gsub('%.', ''):match("   : $.+%(%+$(.+)%)") or text:gsub(',', ''):gsub('%.', ''):match("   : VC$.+%(%+VC$(.+)%)") 		--    : $142572077 {33AA33}(+$700146)
		--    : VC$0 (+VC$0)
		if tonumber(depmoney) ~= nil then 
			deposit = deposit + tonumber(depmoney) 		
			elseif tonumber(depmoney) == nil then
				local depmoney,mon = text:gsub(',', ''):gsub('%.', ''):match("  %: %$(.+) %(     %: $(.+)%)")
				--   : $1.509.637 (     : $15.096)
			if tonumber(depmoney) ~= nil and tonumber(mon) ~= nil then 
				deposit = deposit + (tonumber(depmoney) - tonumber(mon))
				else
				errormsg('   ')
			end
		end
		j[nick][date].deposit = deposit
		json.save(j,'salary.json')
	end	
	if string.find(text,"") then
		if nick == nil then nick = sampGetPlayerNickname(select(2, sampGetPlayerIdByCharHandle(playerPed))) end
		if string.find(text,nick .. " ") then
			local money,place = text:gsub(',', ''):gsub('%.', ''):match(nick .. "  $(.+)  (.+)")
			if money ~= nil and place ~= nil then 
				events = "  " .. place
				else
				errormsg('   ')
			end
		end
	end
	--  -- 
	if string.find(text," ") then
		countPD = countPD + 1
		j[nick][date].payday = countPD
		json.save(j,'salary.json')
	end
	--   -: 973 AZ {ff6666}(+4 AZ)
	if string.find(text,"  %-:") then
		azmoney = text:gsub(',', ''):gsub('%.', ''):match("  %-:.+%(%+(.+) AZ%)")
		if tonumber(azmoney) ~= nil then
			azcoins = azcoins + tonumber(azmoney) else 
			errormsg('   -')
		end
		j[nick][date].azcoins = azcoins
		json.save(j,'salary.json')
	end
	if string.find(text,'   :') then
		orgmoney = text:gsub(',', ''):gsub('%.', ''):match("   : $.+%(%+$(.+)%)") or text:gsub(',', ''):gsub('%.', ''):match("   : VC$.+%(%+VC$(.+)%)") 
		if tonumber(orgmoney) ~= nil then --    : VC$0 (+VC$0)
			orgsalary = orgsalary + tonumber(orgmoney) else
			errormsg('    ') 
		end
		j[nick][date].orgsalary = orgsalary
		json.save(j,'salary.json')
	end	--        . 
	if string.find(text,"   ") then
		local item = text:match("   (.+)")
		if item ~= nil then events = " " .. item else errormsg('   ') end
	end
	if string.find(text,"  ") then
		local item = text:match("   (.+)")
		if item ~= nil then events = " " .. item else errormsg('   ') end
	end
	if string.find(text," ") then
		local item = text:match("  (.+)")
		if item ~= nil then events = " " .. item else errormsg('   ') end
	end
	if string.find(text,"  ") then
		local player,item = text:match("(.+)    (.+),  ")
		if item ~= nil then events = " " .. item else errormsg('   ') end
	end
	--   -- 
	if string.find(text,"    ") then
		if bankCounting.v then banking = true end
		events = "  "
	end
	if string.find(text,"    ") then
		if bankCounting.v then banking = true end
		events = "  "
		
	end
	if string.find(text,"     ") then
		events = "   "
		if bankCounting.v then banking = true end
	end
	if string.find(text,"  (.+)    (.+)  (.+) ") then
		local cars,names,times = text:match("  (.+)    (.+)  (.+) ")
		events = " " .. cars .. "    " .. times
	end
	if string.find(text,"    ") then
		events = "   "
		if bankCounting.v then banking = true end
	end
	if string.find(text,"%[%] : %$(.+)") then
		events = "/   "
		if bankCounting.v then banking = true end
	end
	if string.find(text," ") then
		local money,player = text:gsub(',', ''):gsub('%.', ''):match("  $(.+)  (.+)  ")
		if money ~= nil and player ~= nil then 
			events = "   " .. player
			customJson(money,events)
			else
			errormsg('   ')
		end
	end
	if string.find(text,"(.+) %(%)  %$(.+)") then
		name,money = text:match("(.+) %(%)  %$(.+)")
		events = "   "..name
	end
	if string.find(text,"    (.+)    (.+)  (.+)") then
		local item,hour,same = text:match("    (.+)    (.+)  (.+)")
		if item ~= nil then events = "   "..item else events = "   " end
	end
	if string.find(text,"    %(%( (.+) %)%)") then
		local names = text:match("    %(%( (.+) %)%)")
		if names == nickname then 
			events = "  "
		end
	end
	if string.find(text,"%[VIP ADV%] %[(.+)%] {FFFFFF}(.+)%[(.+)%]") then
		local status,names,idus = text:match('%[VIP ADV%] %[(.+)%] {FFFFFF}(.+)%[(.+)%]')
		if names == nickname then 
			events = " VIP-"
		end
	end
end

function checkingJson()
	
	date   = tonumber(os.date("%d"))
	dayEst = tonumber(os.date("%d")) - 1
	
	date    = tostring(formatDate(date))
	dateEst = tostring(formatDate(dayEst))
	
	if j == {} or j == nil then 
		j = {
			[nick] = {
				settings = 
				{
					x=0,
					y=0,
					fontsize=20,
			stats=true,
			banking=false,
			detailStats=false,
			nowStats=true,
			estStats=true,
			sessionStats=true
				},
				[date] = 
				{
					log={}	
				},
				[dateEst] = 
				{
					log={}
					
				}			
			}
		}
		json.save(j,'salary.json')
		else 
	end
	
	if j[nick] == nil then 
		j[nick] = {
			settings = 
			{
				x=0,
				y=0,
				fontsize=20,
			stats=true,
			banking=false,
			detailStats=false,
			nowStats=true,
			estStats=true,
			sessionStats=true
			},
			[date] = 
			{
				log={}	
			},
			[dateEst] = 
			{
				log={}
				
			}			
		}
		json.save(j,'salary.json')
		else 
	end
	
	if j[nick] == nil then
		j[nick] = {}
		json.save(j,'salary.json')
	end
	
	if j[nick][date] == nil then 
		j[nick][date] = 
		{
			log={}
		}
		json.save(j,'salary.json')
	end
	if j[nick][dateEst] == nil then 
		j[nick][dateEst]=	
		{
			log={}			
		}
		json.save(j,'salary.json')
	end
	
	if j[nick].settings == nil then 
		j[nick].settings= {
			x=0,
			y=0,
			fontsize=20,
			stats=true,
			banking=false,
			detailStats=false,
			nowStats=true,
			estStats=true,
			sessionStats=true
		}
		json.save(j,'salary.json')
	end
end

function writejson(diff) --  JSON    
	local dateDay = formatDate(os.date("%d"))
	if j[nick][dateDay] == nil then checkingJson() end
	table.insert(j[nick][dateDay].log,{
		time = os.time() or 0,
		editMoney = diff or 0,
		eventsMoney = events or "",
		cash = getPlayerMoney()
	})
	table.sort(j[nick][dateDay],function(a,b) return a.time > b.time end) --    
	table.sort(j[nick][dateDay].log,function(a,b) 
		if b ~= nil and a ~= nil then 
			return a.time > b.time 
		end
	end)
	json.save(j,'salary.json') --   json    j
end

function summMoney(date)
	local s = 0
	for k,v in pairs(j[nick][date].log) do
		s = s + v.editMoney
	end
	return s
end

function formatDate(arg) 
	
	--[[local day = arg
		local month = tonumber(os.date("%m"))
		local year = tonumber(os.date("%y"))
		if tonumber(day) <= 0 then 
		month = tonumber(os.date("%m")) - 1
		if month == 0 then 
		year = tonumber(os.date("%y")) - 1
		month = 12
		end		
		if month == 01 or month == 03 or month == 05 or month == 07 or month == 08 or month == 10 or month == 12 then chday = 31 
		elseif month == 02 then chday = 28
		elseif month == 04 or month == 06 or month == 09 or month == 11 then chday = 30 
		end
		if tonumber(day) < 0 then
		chday = chday - math.abs(day)
		day = chday
		else day = chday
		end
		oldDate = day .. month .. year
		end
		oldDate = day .. (month <= 9 and "0"..month or month) .. year
	return tostring(math.abs(oldDate))  ]]--
	
	local time = os.date('*t')
    time.day = arg
    time = os.date('*t', os.time(time)) -- align the time
    return ('%02d%02d%02d'):format(time.day, time.month, time.year % 100)
end

function customJson(dif,events)
	dif = tonumber(dif)
	local dateDay = formatDate(os.date("%d"))
	table.insert(j[nick][dateDay],{ --     ,   
		time = os.time(), --   
		editMoney = dif, --    
		eventsMoney = events or ""
	})
	table.sort(j[nick][dateDay],function(a,b) return a.time > b.time end) --    
	json.save(j,'salary.json') --   json    j	
end

function countWeekSalary(bidon)
	local sumWeek = 0
	local day = bidon
	for i = 1,7 do
		local week = formatDate(day)
		if j[nick][week] ~= nil then
			if j[nick][week].salary ~= nil then
				sumWeek = sumWeek + j[nick][week].salary
			end
		end
		day = day + 1
	end
	return sumWeek
end

function deleteStats()
	
	j = {}
	json.save(j,'salary.json')
	thisScript():reload()
end

function sep(n)
	local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d%d)','%1.'):reverse())..right
end

function sepDate(n)
	local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d)','%1.'):reverse())..right
end

function perechet()
	salary = summMoney(date)
	j[nick][date].salary=salary
	json.save(j,'salary.json')
end

function tablelength(T)
	local count = 0
	for _ in pairs(T) do count = count + 1 end
	return count
end

function imgui.TextColoredRGB(text)
	local style = imgui.GetStyle()
	local colors = style.Colors
	local ImVec4 = imgui.ImVec4
	
	local explode_argb = function(argb)
		local a = bit.band(bit.rshift(argb, 24), 0xFF)
		local r = bit.band(bit.rshift(argb, 16), 0xFF)
		local g = bit.band(bit.rshift(argb, 8), 0xFF)
		local b = bit.band(argb, 0xFF)
		return a, r, g, b
	end
	
	local getcolor = function(color)
		if color:sub(1, 6):upper() == 'SSSSSS' then
			local r, g, b = colors[1].x, colors[1].y, colors[1].z
			local a = tonumber(color:sub(7, 8), 16) or colors[1].w * 255
			return ImVec4(r, g, b, a / 255)
		end
		local color = type(color) == 'string' and tonumber(color, 16) or color
		if type(color) ~= 'number' then return end
		local r, g, b, a = explode_argb(color)
		return imgui.ImColor(r, g, b, a):GetVec4()
	end
	
	local render_text = function(text_)
		for w in text_:gmatch('[^\r\n]+') do
			local text, colors_, m = {}, {}, 1
			w = w:gsub('{(......)}', '{%1FF}')
			while w:find('{........}') do
				local n, k = w:find('{........}')
				local color = getcolor(w:sub(n + 1, k - 1))
				if color then
					text[#text], text[#text + 1] = w:sub(m, n - 1), w:sub(k + 1, #w)
					colors_[#colors_ + 1] = color
					m = n
				end
				w = w:sub(1, n - 1) .. w:sub(k + 1, #w)
			end
			if text[0] then
				for i = 0, #text do
					imgui.TextColored(colors_[i] or colors[1], u8(text[i]))
					imgui.SameLine(nil, 0)
				end
				imgui.NewLine()
			else imgui.Text(u8(w)) end
		end
	end
	
	render_text(text)
end

function onWindowMessage(msg, wparam, lparam)
    if msg == 0x100 or msg == 0x101 then
        if wparam == keys.VK_ESCAPE and showMainWindow.v then
            consumeWindowMessage(true, false)
            if msg == 0x101 then showMainWindow.v = false end
		end
	end
end

function uu()
	for i = 0,5 do
		menu[i] = false
	end
end

function onExitScript(quitGame)
	showCursor(false)
end

function string.nlower(s)
    s = lower(s)
    local len, res = #s, {}
    for i = 1, len do
        local ch = sub(s, i, i)
        res[i] = ul_rus[ch] or ch
	end
    return concat(res)
end

function string.nupper(s)
    s = upper(s)
    local len, res = #s, {}
    for i = 1, len do
        local ch = sub(s, i, i)
        res[i] = lu_rus[ch] or ch
	end
    return concat(res)
end

function styleimgui()
	
	local style = imgui.GetStyle()
	local colors = style.Colors
	local clr = imgui.Col
	local ImVec4 = imgui.ImVec4
	local ImVec2 = imgui.ImVec2
	
	style.WindowPadding = imgui.ImVec2(8, 8)
	style.WindowRounding = 6
	style.ChildWindowRounding = 5
	style.FramePadding = imgui.ImVec2(5, 3)
	style.FrameRounding = 3.0
	style.ItemSpacing = imgui.ImVec2(5, 4)
	style.ItemInnerSpacing = imgui.ImVec2(4, 4)
	style.IndentSpacing = 21
	style.ScrollbarSize = 10.0
	style.ScrollbarRounding = 13
	style.GrabMinSize = 8
	style.GrabRounding = 1
	style.WindowTitleAlign = imgui.ImVec2(0.5, 0.5)
	style.ButtonTextAlign = imgui.ImVec2(0.5, 0.5)
	
	colors[clr.Text]                   = ImVec4(0.95, 0.96, 0.98, 1.00);
	colors[clr.TextDisabled]           = ImVec4(0.29, 0.29, 0.29, 1.00);
	colors[clr.WindowBg]               = ImVec4(0.14, 0.14, 0.14, 1.00);
	colors[clr.ChildWindowBg]          = ImVec4(0.12, 0.12, 0.12, 1.00);
	colors[clr.PopupBg]                = ImVec4(0.08, 0.08, 0.08, 0.94);
	colors[clr.Border]                 = ImVec4(0.14, 0.14, 0.14, 1.00);
	colors[clr.BorderShadow]           = ImVec4(1.00, 1.00, 1.00, 0.10);
	colors[clr.FrameBg]                = ImVec4(0.22, 0.22, 0.22, 1.00);
	colors[clr.FrameBgHovered]         = ImVec4(0.18, 0.18, 0.18, 1.00);
	colors[clr.FrameBgActive]          = ImVec4(0.09, 0.12, 0.14, 1.00);
	colors[clr.TitleBg]                = ImVec4(0.14, 0.14, 0.14, 0.81);
	colors[clr.TitleBgActive]          = ImVec4(0.14, 0.14, 0.14, 1.00);
	colors[clr.TitleBgCollapsed]       = ImVec4(0.00, 0.00, 0.00, 0.51);
	colors[clr.MenuBarBg]              = ImVec4(0.20, 0.20, 0.20, 1.00);
	colors[clr.ScrollbarBg]            = ImVec4(0.02, 0.02, 0.02, 0.39);
	colors[clr.ScrollbarGrab]          = ImVec4(0.36, 0.36, 0.36, 1.00);
	colors[clr.ScrollbarGrabHovered]   = ImVec4(0.18, 0.22, 0.25, 1.00);
	colors[clr.ScrollbarGrabActive]    = ImVec4(0.24, 0.24, 0.24, 1.00);
	colors[clr.ComboBg]                = ImVec4(0.24, 0.24, 0.24, 1.00);
	colors[clr.CheckMark]              = ImVec4(1.00, 0.28, 0.28, 1.00);
	colors[clr.SliderGrab]             = ImVec4(1.00, 0.28, 0.28, 1.00);
	colors[clr.SliderGrabActive]       = ImVec4(1.00, 0.28, 0.28, 1.00);
	colors[clr.Button]                 = ImVec4(1.00, 0.28, 0.28, 1.00);
	colors[clr.ButtonHovered]          = ImVec4(1.00, 0.39, 0.39, 1.00);
	colors[clr.ButtonActive]           = ImVec4(1.00, 0.21, 0.21, 1.00);
	colors[clr.Header]                 = ImVec4(1.00, 0.28, 0.28, 1.00);
	colors[clr.HeaderHovered]          = ImVec4(1.00, 0.39, 0.39, 1.00);
	colors[clr.HeaderActive]           = ImVec4(1.00, 0.21, 0.21, 1.00);
	colors[clr.ResizeGrip]             = ImVec4(1.00, 0.28, 0.28, 1.00);
	colors[clr.ResizeGripHovered]      = ImVec4(1.00, 0.39, 0.39, 1.00);
	colors[clr.ResizeGripActive]       = ImVec4(1.00, 0.19, 0.19, 1.00);
	colors[clr.CloseButton]            = ImVec4(0.40, 0.39, 0.38, 0.16);
	colors[clr.CloseButtonHovered]     = ImVec4(0.40, 0.39, 0.38, 0.39);
	colors[clr.CloseButtonActive]      = ImVec4(0.40, 0.39, 0.38, 1.00);
	colors[clr.PlotLines]              = ImVec4(0.61, 0.61, 0.61, 1.00);
	colors[clr.PlotLinesHovered]       = ImVec4(1.00, 0.43, 0.35, 1.00);
	colors[clr.PlotHistogram]          = ImVec4(1.00, 0.21, 0.21, 1.00);
	colors[clr.PlotHistogramHovered]   = ImVec4(1.00, 0.18, 0.18, 1.00);
	colors[clr.TextSelectedBg]         = ImVec4(1.00, 0.32, 0.32, 1.00);
	colors[clr.ModalWindowDarkening]   = ImVec4(0.26, 0.26, 0.26, 0.60);
	
	
end
styleimgui()



